<?php
/*
Plugin Name: LCAS
Version: 2.1.0
Description: Allow to disable login/register name to be sensible to the case/accents
Plugin URI: http://fr.piwigo.org/forum/viewtopic.php?pid=158563
Author: Eric, LucMorizur, Whiler
Author URI: http://www.infernoweb.net, http://blogs.wittwer.fr/whiler/
*/

/* History:  LCAS_PATH.'Changelog.txt.php' */

/*
 ***** TODO List *****
See project bugtracker: http://piwigo.org/bugs/my_view_page.php
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
if (!defined('LCAS_DIR')) define('LCAS_DIR' , basename(dirname(__FILE__)));
if (!defined('LCAS_PATH')) define('LCAS_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');

include_once (LCAS_PATH.'include/constants.php');
include_once (LCAS_PATH.'include/functions.inc.php');

load_language('plugin.lang', LCAS_PATH);


/* Plugin admin */
add_event_handler('get_admin_plugin_menu_links', 'LCAS_admin_menu');

function LCAS_admin_menu($menu)
{
// +-----------------------------------------------------------------------+
// |                      Getting plugin name                              |
// +-----------------------------------------------------------------------+
  $plugin =  LCAS_PluginInfos(LCAS_PATH);
  $name = $plugin['name'];
  
  array_push($menu,
    array(
      'NAME' => $name,
      'URL'  => get_admin_plugin_menu_link(LCAS_PATH.'/admin/LCAS_admin.php')
    )
  );

  return $menu;
}

// Trigger sensitivity on user identification
if (script_basename() == 'identification')
{
  global $conf;
  
  $conf_LCAS= unserialize($conf['LoginCaseAccentsSensitivity']);
  
  /* Username non case sensitive */
  //if (isset($conf_LCAS[1]) and $conf_LCAS[1] == 'false')
  //{
    // This does not work - Unable to invalidate try_log_user() function
    add_event_handler('login_success', 'LCAS_action');
    add_event_handler('login_failure', 'LCAS_action');
    
    function LCAS_action()
    {
  global $conf;
  // retrieving the encrypted password of the login submitted
  $query = '
SELECT '.$conf['user_fields']['id'].' AS id,
       '.$conf['user_fields']['password'].' AS password
  FROM '.USERS_TABLE.'
  WHERE LOWER('.$conf['user_fields']['username'].') = \''.pwg_db_real_escape_string(strtolower($_POST['username'])).'\'
;';
  $row = pwg_db_fetch_assoc(pwg_query($query));
  if ($row['password'] == $conf['pass_convert']($_POST['password']))
  {
    //log_user($row['id'], $remember_me);
    //trigger_action('login_success', stripslashes($_POST['username']));
    //return true;
$var1 = 'Typed login : '.$_POST['username'];
$var2 = 'Typed login lowercase : '.strtolower($_POST['username']);
$var3 = 'Typed pwd hash : '.$conf['pass_convert'] ($_POST['password']);
$var4 = 'Pwd hash in DB : '.$row['password'];
$var5 = 'User ID in DB : '.$row['id'];
/* ********************** */
DebugLog($var1,$var2,$var3,$var4,$var5);
/* ********************** */

  }
  //trigger_action('login_failure', stripslashes($_POST['username']));
  return false;
    }
  //}
}
?>